(* altp.ml: type declarations in a module. Several of these are
   alternative versions of bindings in Pervasives such as for list and
   option, thus the name "Alternate Pervasives: Altp". *)

type fruit =                    (* algebraic type *)
  | Apple
  | Orange
  | Grapes of int;;

type 'a list =                  (* custom list type *)
  | []
  | (::) of 'a * 'a list
;;

type 'a option =                (* custom option type *)
  | None
  | Some of 'a
;;

type ('a, 'b) namedpair = {     (* a parameterized record *)
    first  : 'a;
    second : 'b;
};;

let makepair a b =              (* a function *)
  {first = a; second = b;}
;;
                            
