(* intoptset.ml: exercise to create an interface to Set.Make for int
   options and demonstration of use. *)

(* specify interface to Set.Make *)
module IntOptElem = struct
  type t = int option;;
  let compare x y =
    match x,y with
    | None,None -> 0
    | None,_    -> -1
    | _,None    -> +1
    | Some x,Some y -> x-y
  ;;
end;;

(* call the functor *)
module IntOptSet =
  Set.Make(IntOptElem);;

(* Demo use of new module *)
let _ =
  let empty = IntOptSet.empty in
  let ios1 =
    IntOptSet.add (Some 5) empty
  in
  let ios2 =
    IntOptSet.add (Some 1) ios1
  in
  let ios3 =
    IntOptSet.add None     ios2
  in
  let ios4 =
    IntOptSet.add (Some 9) ios3
  in
  let sum_some io sum =
    match io with
    | None -> sum
    | Some i -> sum + i
  in
  let sum =
    IntOptSet.fold sum_some ios4 0
  in
  Printf.printf "Sum is %d\n" sum;
;;
