(* local_open.ml: demo use two
   methods to locally open a module *)
open Printf;;

(* let/open/Mod local open *)
let _ =   
  let lst1 = [1;2;3] in
  let lst2 = ["a";"b"] in
  let (len1,len2) =
    let open List in
    (length lst1, length lst2)
  in (* end of local open *)
  printf "%d %d %d\n" len1 len2;

  let open List in
  begin
    printf "%d\n" (hd lst1);
    printf "%s\n" (hd (tl lst2))
  end (* end of local open *)
;;

(* Mod.(..) local open *)
let _ =
  let lst1 = [1;2;3] in
  let lst2 = ["a";"b"] in
  let (len1,len2) =
    List.(length lst1, length lst2)
             (* end of local open ^ *)
  in
  printf "%d %d %d\n" len1 len2;

  List.(printf "%d\n" (hd lst1);
        printf "%s\n" (hd (tl lst2));
  ); (* end of local open *)
;;
