(* use_top_mod.ml: main program which uses Topmod and Topmod.Nestmod
   to demonstrate some name qualification and binding issues. Compile
   together with topmod.ml as in

   ocamlc topmod.ml use_topmod.ml

   After opening modules, bindings in Topmod and Nestmod can be
   referened as "bare names" without module qualification
*)
open Printf;;

(* a main function *)
let _ =
  printf "%s %d\n" Topmod.top_val1 Topmod.top_val2;
  printf "%f %b\n" Topmod.Nestmod.nest_val1 Topmod.Nestmod.nest_val2;
  printf "%s %s\n" Topmod.same_name Topmod.Nestmod.same_name;
;;

(* an equivalent main function after opening Topmod *)
open Topmod;;
let _ =
  printf "%s %d\n" top_val1 top_val2;
  printf "%f %b\n" Nestmod.nest_val1 Nestmod.nest_val2;
  printf "%s %s\n" same_name Nestmod.same_name;
;;

(* an equivalent main function after opening Topmod.Nestmod *)

open Topmod.Nestmod;;
let _ =
  printf "%s %d\n" top_val1 top_val2;
  printf "%f %b\n" nest_val1 nest_val2;
  printf "%s %s\n" Topmod.same_name same_name; (* why qualified? *) 
(* Nestmod opened most recently so qualify first same_name *)
;;
